/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package SDKBullsAndCows;

import java.util.LinkedList;
import java.util.Random;

/**
 *
 * @author User
 */
public class SDKBullsAndCows extends javax.swing.JFrame {

    int computerNumber = 0;

    /**
     * Creates new form SDKBullsAndCows
     */
    public SDKBullsAndCows() {
        initComponents();
        Random r = new Random();

        // Създаваме списък от възможни 10 цифри за числото
        LinkedList<Integer> digitsList = new LinkedList<>();
        for (int i = 0; i <= 9; i++) {
            digitsList.add(i);
        }

        // Вадим поредна произволна цифра от списъка с възможни
        // и я натрупваме на съответна позиция в крайното число
        // като умножаваме всяка съответно с 1, 10, 100 и 1000 (x)
        int x = 1;
        for (int i = 0; i <= 3; i++) {
            // Ако 0 все още не е избрана, а трябва да изберем първа
            // цифра, то премахваме 0, за да не можем да я изберем
            if (i == 3 && digitsList.get(0).equals(0)) {
                digitsList.remove(0);
            }
            // Подбираме произволен индекс
            int randIndex = r.nextInt(digitsList.size());
            // Натрупваме цифрата в крайния резултат
            computerNumber = computerNumber + digitsList.get(randIndex) * x;
            // Премахваме избраната цифра от списъка
            digitsList.remove(randIndex);
            x = x * 10;
        }
        System.out.println(computerNumber);

        /* Стар вариант - генерира произволно число докато не стане с различни цифри
        boolean numberIsValid = true;
        do{ 
            numberIsValid = true;
            computerNumber = 1000+ r.nextInt(9000);
            String computerNumberAsString = ""+computerNumber;
            for(int i=0; i<computerNumberAsString.length()-1; i=i+1){
                for(int j=i+1; j<computerNumberAsString.length(); j=j+1){
                    if(computerNumberAsString.charAt(i) == computerNumberAsString.charAt(j)){
                        numberIsValid = false;
                    }
                }
            }
            if(computerNumberAsString.charAt(0)=='0'){
                numberIsValid = false;
            }
        }
        while(numberIsValid == false);
        System.out.println(computerNumber);
         */
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        checkPanel = new javax.swing.JPanel();
        guess = new javax.swing.JTextField();
        checkButton = new javax.swing.JButton();
        statusPanel = new javax.swing.JPanel();
        triesPanel = new javax.swing.JPanel();
        triesLabel = new javax.swing.JLabel();
        tries = new javax.swing.JLabel();
        messagePanel = new javax.swing.JPanel();
        statusMessage = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridLayout(2, 1));

        guess.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        guess.setMaximumSize(new java.awt.Dimension(70, 35));
        guess.setMinimumSize(new java.awt.Dimension(70, 35));
        guess.setPreferredSize(new java.awt.Dimension(70, 35));
        checkPanel.add(guess);

        checkButton.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        checkButton.setText("Провери");
        checkButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkButtonActionPerformed(evt);
            }
        });
        checkPanel.add(checkButton);

        getContentPane().add(checkPanel);

        statusPanel.setLayout(new java.awt.BorderLayout());

        triesLabel.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        triesLabel.setText("Опити: ");
        triesPanel.add(triesLabel);

        tries.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        tries.setText("0");
        triesPanel.add(tries);

        statusPanel.add(triesPanel, java.awt.BorderLayout.LINE_END);

        statusMessage.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        statusMessage.setText("Въведете число с 4 различни цифри");
        messagePanel.add(statusMessage);

        statusPanel.add(messagePanel, java.awt.BorderLayout.CENTER);

        getContentPane().add(statusPanel);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void checkButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkButtonActionPerformed
        // Проверка дали са точно четири символа
        if (guess.getText().length() != 4) {
            statusMessage.setText("Трябва да са 4 различни цифри!");
            return;
        }

        // Проверка дали е число
        int theGuess;
        try {
            theGuess = Integer.parseInt(guess.getText());
        } catch (NumberFormatException e) {
            statusMessage.setText("Въвете само цифри!");
            return;
        }

        // Проверка дали числото не започва с 0, което не е позволено
        /* 1 начин
        if(guess.getText().charAt(0) == '0'){
            statusMessage.setText("Числото не трябва да започва с 0");
            return;
        }*/
        // 2 начин
        if (theGuess < 1000) {
            statusMessage.setText("Числото не трябва да започва с 0");
            return;
        }

        /* // Лош вариант за проверка дали са четири различни символа!
            if(guess.getText().charAt(0) == guess.getText().charAt(1)
                ||
           guess.getText().charAt(0) == guess.getText().charAt(2)
                ||
           guess.getText().charAt(0) == guess.getText().charAt(3)
                ||
           guess.getText().charAt(1) == guess.getText().charAt(2)
                ||
           guess.getText().charAt(1) == guess.getText().charAt(3)
                ||
           guess.getText().charAt(2) == guess.getText().charAt(3)
        ){
            statusMessage.setText("Цифрите ви не са различни!");
            return;
        }*/
        // По-добър вариант за проверка дали са четири различни символа
        for (int i = 0; i < guess.getText().length() - 1; i = i + 1) {
            for (int j = i + 1; j < guess.getText().length(); j = j + 1) {
                if (guess.getText().charAt(i) == guess.getText().charAt(j)) {
                    statusMessage.setText("Цифрите Ви не са различни!");
                    return;
                }
            }
        }

        // Увеличаваме опитите с 1
        int currentTries = Integer.parseInt(tries.getText());
        currentTries = currentTries + 1;
        tries.setText("" + currentTries);

        // Проверяваме дали числото е познато
        if (theGuess == computerNumber) {
            statusMessage.setText("УРА! Познахте!");
            guess.setEditable(false);
            checkButton.setEnabled(false);
            return;
        }

        int bikove = 0;
        // 1 начин за намиране на броя бикове
        String cNumStr = "" + computerNumber;
        for (int i = 0; i < cNumStr.length(); i++) { // i++ е същото като i=i+1
            if (cNumStr.charAt(i) == guess.getText().charAt(i)) {
                bikove++;
            }
        }

        int kravi = 0;
        // 1 начин за намиране на броя крави
        for (int i = 0; i < guess.getText().length(); i++) {
            for (int j = 0; j < cNumStr.length(); j++) {
                if (i == j) {
                    continue;
                }
                if (guess.getText().charAt(i) == cNumStr.charAt(j)) {
                    kravi++;
                }
            }
        }
        statusMessage.setText("Бикове: " + bikove + ", Крави: " + kravi);
        
        /*
            2 начин за намиране на броя бикове и крави би бил
            да извършваме целочислени деления на намислените числа
            с 10, 100 и 1000, и да сравняваме техните остатъци
            Например ако компютъра имаме числото 1234, то
            1234 % 10 = 4   - намираме четвъртата цифра
            (1234 % 100)/10 = 34/10 = 3  - намираме третата цифра
            (1234 % 1000)/100 = 234/100 = 2  - намираме втората цифра
            1234 / 1000 = 1  - намираме първата цифра
            Разделяйки числата на съставни части (цифри) и знаейки
            техните позиции, можете да преброите биковете и кравите
            Направете го.
        */
    }//GEN-LAST:event_checkButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(SDKBullsAndCows.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(SDKBullsAndCows.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(SDKBullsAndCows.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SDKBullsAndCows.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new SDKBullsAndCows().setVisible(true);
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton checkButton;
    private javax.swing.JPanel checkPanel;
    private javax.swing.JTextField guess;
    private javax.swing.JPanel messagePanel;
    private javax.swing.JLabel statusMessage;
    private javax.swing.JPanel statusPanel;
    private javax.swing.JLabel tries;
    private javax.swing.JLabel triesLabel;
    private javax.swing.JPanel triesPanel;
    // End of variables declaration//GEN-END:variables
}
